// C Source File
// Created 2/13/2002; 4:23:05 PM

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include <extgraph.h>
//types
typedef struct {unsigned char x,y;} POS;
typedef union {
	unsigned long l;
	struct {unsigned short a,b;} s;
	struct {unsigned char a,b,c,d;} c;
} LENGTHT;
// defs
#define XPOS counter % (LCD_WIDTH/x)*x
#define YPOS counter / (LCD_WIDTH/x)*y
#define XPOSM counter % (LCD_WIDTH/psz.x)*psz.x
#define YPOSM counter / (LCD_WIDTH/psz.x)*psz.y
#define XPOSR scrno[counter] % (LCD_WIDTH/psz.x)*psz.x
#define YPOSR scrno[counter] / (LCD_WIDTH/psz.x)*psz.y	


		//FUNCS!
		unsigned char sqrform(unsigned char x,unsigned char y,unsigned char **ssprite,unsigned long *snum){
		unsigned long counter;
			for (counter=0;counter<*snum + 1;counter++) {
				if ((ssprite[counter]=(unsigned char *)malloc(x/8*y*sizeof(char)))==NULL) {
					for (*snum=0;*snum<counter;*snum++) free((unsigned char *)ssprite[*snum]);
				return 0;	}; //allocate lots of pretty memory to place squares in
			SpriteX8Get(XPOS,YPOS,y,LCD_MEM,ssprite[counter],x/8);
			}//get sprites while allocating memory
			return 1;//all went well
		}
		
		void setscrno(unsigned char *scrno,unsigned long *snum,unsigned long *rv,unsigned long *tmp){
		unsigned long counter;
			for (counter=0;counter<=*snum;counter++) scrno[counter]=*snum-counter; // assign proper scrn vals
			for (counter=0;counter<=*snum;counter++){ 
			*rv=random(*snum+1);
			*tmp=scrno[counter];
			scrno[counter]=scrno[*rv];
			scrno[*rv]=*tmp; }//randomize everything
			for (counter=0;counter<=*snum;counter++){ 
			*rv=random(*snum+1);
			*tmp=scrno[counter];
			scrno[counter]=scrno[*rv];
			scrno[*rv]=*tmp; }//twice
			return;
			}
		unsigned char scrnshft(void *lpln,void *dpln,unsigned char direc,unsigned char **ssprite,unsigned char *scrno,unsigned long *snum,unsigned long *counter,unsigned char x,unsigned char y,unsigned short *results){
			unsigned long mvr=0,dcount;
			
			if ((direc % 2)==0){
				goto Y;
			}
			else {
				goto X;
			}
			X:	
				for (*counter=0;*counter<=*snum;++*counter){
					if ((scrno[*snum]-(direc-2)) == (scrno[*counter])) mvr=*counter;
				}
				for (*counter=1;*counter<(unsigned short)(x+1);++*counter){
				for (dcount=0;dcount<*results;dcount++) rand() % rand();
					GraySpriteX8_XOR((scrno[mvr] % (LCD_WIDTH/x)*x)+(direc-2)*(*counter-1),scrno[mvr] / (LCD_WIDTH/x)*y,y,ssprite[mvr],ssprite[mvr],x/8,lpln,dpln);
					GraySpriteX8_MASK((scrno[mvr] % (LCD_WIDTH/x)*x)+(direc-2)*(*counter),scrno[mvr] / (LCD_WIDTH/x)*y,y,ssprite[mvr],ssprite[mvr],ssprite[mvr],ssprite[mvr],x/8,lpln,dpln);	
				};
				*counter=scrno[*snum];
				scrno[*snum]=scrno[mvr];
				scrno[mvr]=*counter;
				GraySpriteX8_MASK((scrno[*snum] % (LCD_WIDTH/x)*x),scrno[*snum] / (LCD_WIDTH/x)*y,y,ssprite[*snum],ssprite[*snum],ssprite[*snum],ssprite[*snum],x/8,lpln,dpln);
				SpriteX8_XOR((scrno[*snum] % (LCD_WIDTH/x)*x),scrno[*snum] / (LCD_WIDTH/x)*y,y,ssprite[*snum],x/8,dpln);
				goto BTH;
			
			Y:
							for (*counter=0;*counter<=*snum;++*counter){
					if ((scrno[*snum]+(direc-1)*(LCD_WIDTH/x)) == (scrno[*counter])) mvr=*counter;
				}
				for (*counter=1;*counter<(unsigned short)(y+1);++*counter){
				for (dcount=0;dcount<*results;dcount++) rand() % rand();
					GraySpriteX8_XOR((scrno[mvr] % (LCD_WIDTH/x)*x),scrno[mvr] / (LCD_WIDTH/x)*y-(direc-1)*(*counter-1),y,ssprite[mvr],ssprite[mvr],x/8,lpln,dpln);
					GraySpriteX8_MASK((scrno[mvr] % (LCD_WIDTH/x)*x),scrno[mvr] / (LCD_WIDTH/x)*y-(direc-1)*(*counter),y,ssprite[mvr],ssprite[mvr],ssprite[mvr],ssprite[mvr],x/8,lpln,dpln);	
				};
				*counter=scrno[*snum];
				scrno[*snum]=scrno[mvr];
				scrno[mvr]=*counter;
				GraySpriteX8_MASK((scrno[*snum] % (LCD_WIDTH/x)*x),scrno[*snum] / (LCD_WIDTH/x)*y,y,ssprite[*snum],ssprite[*snum],ssprite[*snum],ssprite[*snum],x/8,lpln,dpln);
				SpriteX8_XOR((scrno[*snum] % (LCD_WIDTH/x)*x),scrno[*snum] / (LCD_WIDTH/x)*y,y,ssprite[*snum],x/8,dpln);
			BTH:
					for (*counter=0;*counter<=*snum;*counter += 1){
					if (*counter != scrno[*counter]) return 0;
					}
			return 1;
		}
		
		void delay(unsigned short reps){
			unsigned short count;
			for (count=0;count<reps;count++) rand() % rand();
			return;
		}
		void endseq(){
			unsigned short ab,ba;
			SetPlane(1);
			ClrScr();
			SetPlane(0);
			DrawStr(0,0,"You are teh winna!   ",A_REPLACE);
			DrawStr(0,90,"You are teh winna!   ",A_REPLACE);
			while(!(_rowread(~(short)(1<<6)) & 1)){
				InvertGrayRect(random(LCD_WIDTH),random(LCD_HEIGHT),random(LCD_WIDTH),random(LCD_HEIGHT));
				for(ab=0;ab<3;ab++){
				InvertGrayRect(0,0,LCD_WIDTH-1,LCD_HEIGHT-1);
					for (ba=0;ba<4000;ba++) rand() % rand();
				}
			}
			return;
		}
		
		
		
		
// Main Function
					void _main(void)
					{
					INT_HANDLER save_int;
					POS psz={32,20};
					randomize();
					unsigned long snum,counter=0;
					unsigned char results[5]="400";
					unsigned short *delayrvar=(400);
					unsigned short indx[2]={32,25};
					HANDLE dlogbx,popp,poppy;
					if((dlogbx=DialogNewSimple(LCD_WIDTH-20,LCD_HEIGHT-35))==H_NULL) goto progst;
					if((popp=PopupNew(NULL,30))==H_NULL){HeapFree(dlogbx);
					goto progst;};
					if((poppy=PopupNew(NULL,30))==H_NULL){HeapFree(dlogbx);
					HeapFree(popp);
					goto progst;};
					while(1){
					if(PopupAddText(popp,-1,(char *)"8",8)==H_NULL) break;
					if(PopupAddText(popp,-1,(char *)"16",16)==H_NULL) break;
					if(PopupAddText(popp,-1,(char *)"32",32)==H_NULL) break;
					if(PopupAddText(popp,-1,(char *)"40",40)==H_NULL) break;
					if(PopupAddText(poppy,-1,(char *)"10",10)==H_NULL) break;
					if(PopupAddText(poppy,-1,(char *)"20",20)==H_NULL) break;
					if(PopupAddText(poppy,-1,(char *)"25",25)==H_NULL) break;
					if(PopupAddText(poppy,-1,(char *)"50",50)==H_NULL) break;
					if(DialogAddPulldown (dlogbx,1,13,"Tile width",popp,0)==H_NULL) break;
					if(DialogAddPulldown (dlogbx,1,27,"Tile height",poppy,1)==H_NULL) break;
					if(DialogAddTitle (dlogbx,"game specs",BT_OK,BT_CANCEL)==H_NULL) break;
					if(DialogAddRequest (dlogbx,1,41,"delayrate",0,4,4)==H_NULL) break;
					snum=DialogDo(dlogbx,-1,-1,results,indx);
					if(snum==KEY_ESC) break;
					if(snum==H_NULL) break;
					psz.x=indx[0];
					psz.y=indx[1];
					break;
					}
					*delayrvar=(unsigned short)atoi(results);
					HeapFree(poppy);
				  HeapFree(popp);
					HeapFree(dlogbx);
					progst:
					FillTriangle (random(LCD_WIDTH),17+random(83),random(LCD_WIDTH),17+random(83),random(LCD_WIDTH),17+random(83),(&(SCR_RECT){{0, 0, 159, 99}}),A_SHADE_V);
					FillTriangle (random(LCD_WIDTH),17+random(83),random(LCD_WIDTH),17+random(83),random(LCD_WIDTH),17+random(83),(&(SCR_RECT){{0, 0, 159, 99}}),A_SHADE_H);
					ngetchx();
					void *dpln,*lpln;
					snum=LCD_WIDTH/psz.x*LCD_HEIGHT/psz.y-1;
					LENGTHT mvar;
					unsigned char *ssprite[snum],scrno[snum];
						if (!sqrform(psz.x,psz.y,ssprite,&snum)) return; //use sqrform & see if it worked
					setscrno(scrno,&snum,&counter,&mvar.l);
					save_int = GetIntVec(AUTO_INT_1);
					SetIntVec(AUTO_INT_1, DUMMY_HANDLER);   
					GrayOn();
					lpln=GetPlane(0);
					dpln=GetPlane(1);
					ClearGrayScreen();
						for (counter=0;counter<snum;counter++){
						GraySpriteX8_OR(XPOSR,YPOSR,psz.y,ssprite[counter],ssprite[counter],psz.x/8,lpln,dpln);}
					counter=snum;
					SpriteX8_OR(XPOSR,YPOSR,psz.y,ssprite[counter],psz.x/8,lpln);
						//draws the initial sprites
						while(!(_rowread(~(short)(1<<6)) & 1)){
						whilerun:
						mvar.c.a=_rowread(~(short)(1));
							if (mvar.c.a & (char)(1<<3)){
								if(scrno[snum] % (LCD_WIDTH/psz.x)==0)	goto whilerun;
						  if(scrnshft(lpln,dpln,3,ssprite,scrno,&snum,&counter,psz.x,psz.y,delayrvar)){endseq();break;}
						}
							if (mvar.c.a & (char)(1<<2)){
								if(scrno[snum] / (LCD_WIDTH/psz.x)==0)	goto whilerun;
						  if(scrnshft(lpln,dpln,0,ssprite,scrno,&snum,&counter,psz.x,psz.y,delayrvar)){endseq();break;}
						}
							if (mvar.c.a & (char)(1<<1)){
								if(scrno[snum] % (LCD_WIDTH/psz.x)==LCD_WIDTH/psz.x-1)	goto whilerun;
						  if(scrnshft(lpln,dpln,1,ssprite,scrno,&snum,&counter,psz.x,psz.y,delayrvar)){endseq();break;}
						}
							if (mvar.c.a & (char)(1)){
								if(scrno[snum] / (LCD_WIDTH/psz.x)==LCD_HEIGHT/psz.y-1)	goto whilerun;	
						  if(scrnshft(lpln,dpln,2,ssprite,scrno,&snum,&counter,psz.x,psz.y,delayrvar)){endseq();break;}
						}
	
						}
					GrayOff();
					SetIntVec (AUTO_INT_1, save_int);
					for (counter=0;counter<snum+1;counter++) free(ssprite[counter]);//free sprite mem
					}// done